/*
 * a1-l.0.c
 * Copyright (C) 2011-2017, 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-inter.h>
#include <e4.h>

static int qu_0_call(void *, void *, void **);
static int qu_1_call(void *, void *, void **);
static int qx_0_call(void *, void *, void **);
static int qx_1_call(void *, void *, void **);
static int ru_0_call(void *, void *, void **);
static int rx_0_call(void *, void *, void **);

static const int c_c_m_m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_CASE,
    X1f4_E4_MODE,
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
};
const struct x1f4_function_type _x1f4_a1_0_o = {
/* *INDENT-OFF* */
    "ocall",
    qu_1_call,
    X1f4_E4_VOID,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    5
/* *INDENT-ON* */
}, _x1f4_a1_0_q_u = {
/* *INDENT-OFF* */
    "qucall",
    qu_0_call,
    X1f4_E4_VOID,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    6
/* *INDENT-ON* */
}, _x1f4_a1_0_q_x = {
/* *INDENT-OFF* */
    "qxcall",
    qx_0_call,
    X1f4_E4_CASE,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    6
/* *INDENT-ON* */
}, _x1f4_a1_0_r = {
/* *INDENT-OFF* */
    "rcall",
    qx_1_call,
    X1f4_E4_CASE,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    5
/* *INDENT-ON* */
}, _x1f4_a1_0_r_u = {
/* *INDENT-OFF* */
    "rucall",
    ru_0_call,
    X1f4_E4_VOID,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    6
/* *INDENT-ON* */
}, _x1f4_a1_0_r_x = {
/* *INDENT-OFF* */
    "rxcall",
    rx_0_call,
    X1f4_E4_CASE,
    c_c_m_m_m,
    4,
    X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS | X1f4_E4_SIDE_LIST
    | X1f4_E4_WALK_LINK,
    6
/* *INDENT-ON* */
};

static int
qu_0_call(void *context, void *output, void **input)
{
    return _x1f4_a1_draw_call(context, output, input, 1, "qucall", 6);
}


static int
qu_1_call(void *context, void *output, void **input)
{
    return _x1f4_a1_draw_call(context, output, input, 1, "ocall", 5);
}


static int
qx_0_call(void *context, void *output, void **input)
{
    return _x1f4_a1_into_call(context, output, input, 1, "qxcall", 6);
}


static int
qx_1_call(void *context, void *output, void **input)
{
    return _x1f4_a1_into_call(context, output, input, 1, "rcall", 5);
}


static int
ru_0_call(void *context, void *output, void **input)
{
    return _x1f4_a1_draw_call(context, output, input, 0, "rucall", 6);
}


static int
rx_0_call(void *context, void *output, void **input)
{
    return _x1f4_a1_into_call(context, output, input, 0, "rxcall", 6);
}
