/*
 * a12nd.i.c
 * Copyright (C) 2006-2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-inter.h>
#include <e4.h>

int
_x1f4_a1_plan_slip(struct a1_shuffle_type *shuffle_data,
		   struct a1_trans18_type *trans18_data,
		   int *note, void *back, int (*call)(void *))
{
    struct a1_node_type *slip_node;
    struct a1_instant_type *instant_data;

    instant_data = &trans18_data->r.instant;

    shuffle_data->instant_data = instant_data;

    slip_node = shuffle_data->slip_node;
    instant_data->fail_node = slip_node;

    instant_data->shuffle_data = shuffle_data;

    instant_data->m = shuffle_data->m;
    instant_data->v = shuffle_data->v;

    trans18_data->z.back = back;
    trans18_data->z.call = call;
    trans18_data->z.note = note;

    if (slip_node->linetext.function.flags & X1f4_E4_SIDE_LIST) {
	struct x1f4_function_type *function_data;

	function_data = shuffle_data->side;
	instant_data->s.function_data = function_data;
	instant_data->s.lead = function_data + 1;
    }

    return 0;
}
