/*
 * bqfv.b.c
 * Copyright (C) 2009-2012, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
x1f4_line_bqfset(void *bqdata, void *bqtext,
		 int (*copy) (void *, void *, const void *),
		 int (*free) (void *, void *), void *context)
{
    int status;

    if (*(integral_q *) bqfset(bqdata)->link_a.fpnews.node) {
	status = SIZE_ERROR;
    } else {
	if (*(integral_q *) bqfset(bqtext)->link_a.fpnews.node) {
	    if (bqfset(bqtext)->link_a.fpnews.link_v.size
		^ bqfset(bqdata)->link_a.fpnews.link_v.size) {
		status = TEXT_ERROR;
	    } else {
		status = _libx1f4l2_rank_bqfset
		    (bqdata, bqtext, copy, free, context);
	    }
	} else {
	    status = 0;
	}
    }

    return status;
}
