/*
 * bqfv.j.c
 * Copyright (C) 2009-2011, 2014, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <bqfx-defs.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_drag_bqfset(void *bqfset, void **drag)
{
    int status;
    unsigned rate, size;
    void *node = NULL, *root, *sect = NULL;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    rate = bqfset(bqfset)->link_a.fpnews.link_v.rate;

    root = bqfset(bqfset)->link_a.fpnews.node;

    if (rate) {
	size += SIZEOF_integral_q;
    }
    status = bqfset(bqfset)->link_m.link
	(bqfset(bqfset)->link_m.data, &node, integral_q_bits * size);
    if (status) {
    } else {
	status = bqfset(bqfset)->link_m.link
	    (bqfset(bqfset)->link_m.data, &sect, integral_q_bits * size);
    }

    if (status) {
	status = LINK_ERROR;

	if (node) {
	    bqfset(bqfset)->link_m.free(bqfset(bqfset)->link_m.data, node);
	}
    } else {
	drag[0] = node;
	drag[1] = sect;

	*((integral_q *) root) = 1;

	bqfset(bqfset)->link_a.fpnews.link_v.rate++;
    }

    return status;
}
