/*
 * bqfv.n.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <bcount.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>
#include <xls.h>

#define __HALF_TRANSFER__		1

#define __LOSE_DOUBLE__			1

#define __LOSE_METHOD__			__LOSE_DOUBLE__

#define __SINGLE_MERGE__		1

#define __UNROLL_TRANSFER__		0

#define here_two_test(___h) \
    ((___h) & 8192)

#undef here_two_test

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_l_count(___h, ___e) \
    ___n = (___e) & ~Lx55555555;					      \
    ___p = (___n | ___n >> (half_integral_q_bits + 1))			      \
	& ((Q(1) << half_integral_q_bits) - 1);				      \
    if (1) {								      \
	___t = 1024;							      \
    }
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_n_reset(___h)
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_declarations \
    integral_q ___n, ___p, ___t
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_setup(___f, ___g) \
    l2_q_heap_1up(___p);						      \
									      \
    ___p &= Q(0xff) | Q(0xff) << half_integral_q_bits;			      \
									      \
    ___p |= ___t;							      \
    ___p |=								      \
	((___p								      \
	  - ((___t & (Q(1024) | Q(1024) << half_integral_q_bits)) >> 10))     \
	 & (Q(1024) | Q(1024) << half_integral_q_bits)) << 3;		      \
									      \
    (___f) = ___p & ((Q(1) << half_integral_q_bits) - 1)
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#define here_two_test(___h) \
    ((___h) & 8192)

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define lola(___s, ___n) \
    ((char *) (___s) - ((___n) << 1))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define trap(___n, ___s)		((___n) + ((___s) << 2))

#define true(e)				1

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

static int edge(void *, unsigned, unsigned,
		int (*)(void *, void *, unsigned));

static int
edge(void *node, unsigned size, unsigned call,
     int (*move)(void *, void *, unsigned))
{
    integral_q news, slip;

    news = *(integral_q *) node;

    slip = news & ~Lx55555555;

    {
	if (1) {
	    call++;

	    if (call & 1) {
		*(integral_q *) node = news & ~(Q(1) << call);
	    } else {
		if (news & (Q(1) << (call - 1))) {
		    *(integral_q *) node = news & ~(Q(1) << (call - 1));
		    if (2) {
			void *data, **text;

			data = HD(node, size, call);
			move(data, life(data, size), 1);
			call--;
			text = ZD(node, size) + call;
			*text = *(text - 1);
		    }
		} else {
		    if (0) {
		    } else {
			unsigned deck, ever;

			if (0) {
			} else {
			    l2_q_xls(deck, slip & ((Q(1) << call) - 1));
			    if (1) {
				deck ^= integral_q_last;
				if (1) {
				    void *data, **text;

				    *(integral_q *) node =
					news & ~(Q(1) << deck);
				    ever = (call - deck) >> 1;
				    data = rule(node, size, call);
				    call--;
				    text = ZD(node, size) + call;
				    for (; ever; ever--) {
					void *trip;

					trip = lola(data, size);
					move(data, trip, 1);
					data = trip;
					*text = *(text - 2);
					text -= 2;
				    }
				    {
					move(data, life(data, size), 1);
					*text = *(text - 1);
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }

    return 0;
}


int
_libx1f4l2_mint_bqfset(void *bqfset, void *node, integral_q pipe)
{
    int (*move)(void *, void *, unsigned), status;
    integral_q last;
    unsigned deck, ever, size;
    void *club, *file, *head;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    file = ZD(node, size)[integral_q_last];

    if (1) {
	if (pipe & Q(1) << integral_q_last) {
	    club = ZD(node, size)[integral_q_last - 1];
	    head = HD(node, size, integral_q_last);
	} else {
	    if (1) {
		club = ZD(node, size)[integral_q_last - 2];
		head = HD(node, size, integral_q_last - 1);
	    } else {
	    }
	}
	if (0) {
	} else {
	}
    } else {
    }

    status = 0;

    {
	here_two_declarations;

	if (1) {
	    last = *(integral_q *) club;
	    here_two_l_count(deck, last);
	} else {
	}

	if (0) {
	} else {
	    here_two_n_reset(ever);
	}

	here_two_setup(deck, ever);
    }

    if (here_two_test(deck)) {
	if (0) {
	} else {
#if __HALF_TRANSFER__
	    if (1) {
		integral_q text;
		unsigned slip;
		void *fast, *side;

		fast = rule(file, size, integral_q_bits - 2);

		ever = (integral_q_bits - 4) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		if (ever & 1) {
		    side = lola(fast, size);
		    move(fast, side, 1);
		    fast = side;
		}
		ever >>= 1;
		for (; ever; ever--) {
		    side = lola(fast, size);
		    move(fast, side, 1);
		    fast = lola(side, size);
		    move(side, fast, 1);
		}
# endif				/* __UNROLL_TRANSFER__ */

		fast = file;

		deck &= 254;

		if (deck < 4) {
		    deck = 1;

		    *(integral_q *) fast = Lx55555555;

		    dana(fast, size);
		} else {
		    *(integral_q *) fast = Lx55555555
			| ((Q(1) << (deck - 2)) - 1);

		    if (deck < 8) {
			deck >>= 1;

			fast = rule(fast, size, deck);
		    } else {
			fast = rule(fast, size, deck - 3);

			side = life(fast, size);

			deck >>= 1;

			ever = deck - 3;
			for (; ever; ever--) {
			    move(fast, side, 1);
			    beta(side, size);
			    posh(fast, size);
			}
		    }
		}

		move(fast, head, 1);

		posh(fast, size);

		deck--;

		text = *(integral_q *) club;

		side = rule(club, size, integral_q_bits);

		while (deck & ~1) {
		    if (text & Q(1) << integral_q_last) {
			beta(side, size);
			posh(fast, size);
			move(fast, side, 2);
			posh(fast, size);

			deck -= 2;
		    } else {
			deck--;

			beta(side, size);
			move(fast, side, 1);
			posh(fast, size);
		    }

		    text <<= 2;
		}
		if (deck) {
		    if (text & Q(1) << integral_q_last) {
			posh(side, size);
			move(fast, side, 1);
			posh(side, size);
			move(head, side, 1);

			deck = 0;
		    } else {
			beta(side, size);
			move(fast, side, 1);
		    }

		    text <<= 2;
		} else {
		    deck = 1;
		}
		slip = integral_q_bits - 2;
		if (deck) {
		    if (text & Q(1) << integral_q_last) {
			posh(side, size);
			move(head, side, 1);

			posh(side, size);

			fast = rule(club, size, integral_q_bits - 2);

			text <<= 1;
		    } else {
			beta(side, size);
			move(head, side, 1);

			posh(side, size);

			fast = rule(club, size, integral_q_bits - 2);

			text <<= 2;

			if (side < fast) {
			    if (text & Q(1) << integral_q_last) {
				move(fast, side, 1);
				beta(fast, size);
				slip -= 2;
			    }

			    posh(side, size);

			    text <<= 1;
			}
		    }
		} else {
		    posh(side, size);

		    fast = rule(club, size, integral_q_bits - 2);

		    if (side < fast) {
			if (text & Q(1) << integral_q_last) {
			    move(fast, side, 1);
			    beta(fast, size);
			    slip -= 2;
			}

			posh(side, size);

			text <<= 1;
		    }
		}
		while (side < fast) {
		    if (text & Q(1) << (integral_q_bits - 2)) {
			move(fast, side, 1);
			beta(fast, size);
			posh(side, size);
			move(fast, side, 1);
			beta(fast, size);
			posh(side, size);
			slip -= 4;
		    } else {
			move(fast, side, 1);
			beta(fast, size);
			beta(side, size);
			slip -= 2;
		    }

		    text <<= 2;
		}

		*(integral_q *) club = Lx55555555
		    | text >> (integral_q_last - slip);
	    }
#else
# error
#endif				/* __HALF_TRANSFER__ */
	}
    } else {
#if __SINGLE_MERGE__
	if (1) {
	    void *fast, *side;

	    *(integral_q *) file = ~Q(2);

	    side = rule(file, size, integral_q_bits - 4);

	    fast = rule(file, size, integral_q_last);

	    deck = (integral_q_bits - 2 - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }
	    {
		move(fast, head, 1);
		posh(fast, size);
	    }

	    side = rule(club, size, integral_q_bits - 2);

	    deck = (integral_q_bits - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }
	    if (deck & 1) {
		move(fast, side, 1);
		posh(fast, size);
		beta(side, size);
	    }

	    if (1) {
		int excess;
		unsigned call;

		if (pipe & Q(1) << integral_q_last) {
		    call = integral_q_bits - 1;
		} else {
		    call = integral_q_bits - 2;
		}

		status = edge(node, size, call - 1, move);

		excess = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, club);
		if (excess) {
		    status = FREE_ERROR;
		}
	    }
	}
#else
	do {
	    unsigned call = integral_q_last;
	    void *fast, *past, *tier = NULL;

	    if (0) {
	    } else {
		if (1) {
		    unsigned copy = integral_q_bits - 2;

		    past = head;

		    _libx1f4l2_nine_bqfset
			(bqfset, last, &club, pipe, &node, &call, &head, &file,
			 &tier, 0, &copy);
		    if (tier) {
		    } else {
			break;
		    }
		}
	    }

	    {
		void *side;

		fast = club;

		*(integral_q *) club = Lxdddddddd ^ Q(1) << integral_q_last;

		if (0) {
		} else {
		    fast = rule(fast, size, 4);

		    side = life(fast, size);

		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		deck = (integral_q_bits - 6) / 6;
		for (; deck; deck--) {
		    move(side, fast, 1);
		    dana(fast, size);
		    dana(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			move(side, fast, 1);

			fast = file;

			dana(fast, size);
			dana(side, size);
			move(side, head, 1);
			skip(side, size);
			move(side, fast, 1);
			skip(side, size);
		    } else {
			move(side, fast, 1);
			dana(fast, size);
			dana(side, size);
			move(side, fast, 1);

			fast = file;

			skip(side, size);
			move(side, head, 1);
			skip(side, size);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		}

		{
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		}

		fast = rule(tier, size, integral_q_bits);

		side = fast;

		deck = integral_q_bits / 6;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			fast = rule(file, size, integral_q_bits - 4);

			posh(side, size);
			move(side, past, 1);
			posh(side, size);
			move(side, fast, 1);
			beta(side, size);
			beta(fast, size);
			move(side, fast, 1);
		    } else {
			posh(side, size);
			beta(fast, size);
			move(side, fast, 1);

			fast = rule(file, size, integral_q_bits - 4);

			posh(side, size);
			move(side, past, 1);
			beta(side, size);
			move(side, fast, 1);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		{
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		*(integral_q *) tier = Lxdddddddd;
	    }

	    if (1) {
		int excess;

		move(head, cell(fast, size, 2), 1);

		status = edge(node, size, call, move);

		excess = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, file);
		if (excess) {
		    status = FREE_ERROR;
		}
	    } else {
	    }
	} while (0);
#endif				/* __SINGLE_MERGE__ */
    }

    return status;
}
