/*
 * c12nd.u.c
 * Copyright (C) 2010-2013, 2016, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1-types.h>
#include <e4.h>
#include <lxcast.h>

#define I_USER(i)			(*((X1f4_E4_C_USER *) (i)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_x1f4_c1_back_cast(void *program, void *output, void **input)
{
    int status;
    struct c1_hold_type *upcast_data;
    struct x1f4_dxcast_type *dxcast_data;
    void *text, **used;

    text = (void *) ((struct c1_program_type *) program)->v.f.text;

    used = input[-1];

    upcast_data = used[X1f4_E4_LEAD_BACK];

    upcast_data->text = text;

    dxcast_data = (void *) (upcast_data + 1);

    *dxcast_data = *(struct x1f4_dxcast_type *) I_USER(input[0]);

    dxcast_data->call = 0;

    status = x1f4_lead_lxcast(text, (void *) &dxcast_data);
    if (status) {
	dxcast_data->type = X1f4_E4_MODE;
    } else {
	upcast_data->node = dxcast_data;
	upcast_data->slip = x1f4_slip_lxcast;

	l_USER(dxcast_data, output);
    }

    return status;
}
