/*
 * e4-e.j.c
 * Copyright (C) 2006-2012, 2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4-defs.h>
#include <e4-inter.h>
#include <e4-types.h>

#define EXPRESSION(expression) \
    ((e4_expression_type *) expression)

#define E_FREE(mcontext, mdata) \
    (EXPRESSION(mcontext)->m.free(EXPRESSION(mcontext)->m.data, (mdata)))
#define E_MODE(mcontext, mdata, size) \
    (EXPRESSION(mcontext)->m.mode					      \
	(EXPRESSION(mcontext)->m.data, (void *) (mdata), (size)))

int
_x1f4_e4_sink_expression(struct e4_expression_type *expression_data)
{
    int status = 0;
    unsigned list, post;

    _x1f4_e4_size_expression(expression_data, &list, &post);
    if (expression_data->bits & EXTERN_STACKS_MESS) {
	expression_data->list_size = list;
	expression_data->post_size = post;
    } else {
	if (expression_data->list_size != list) {
	    if (list) {
		status = E_MODE
		    (expression_data, &expression_data->list,
		     sizeof(void *) * list);
		if (status) {
		} else {
		    expression_data->list_size = list;
		}
	    } else {
		E_FREE(expression_data, expression_data->list);
		expression_data->list = NULL;
		expression_data->list_size = 0;
	    }
	}
	if (status) {
	} else {
	    if (expression_data->post_size != post) {
		if (post) {
		    status = E_MODE
			(expression_data, &expression_data->post_data,
			 sizeof(struct e4_post_type) * post);
		    if (status) {
		    } else {
			expression_data->post_size = post;
		    }
		} else {
		    E_FREE(expression_data, expression_data->post_data);
		    expression_data->post_data = NULL;
		    expression_data->post_size = 0;
		}
	    }
	}
    }

    return status;
}
