/*
 * e4.7.7.c
 * Copyright (C) 2019, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * for double references load_ever does the job without help from neon#3.
 */

#include <e4-config.h>

#include <stddef.h>

#include <e4-defs.h>
#include <e4-line.h>
#include <e4-types.h>
#include <fd.h>

static int neon_pick(x1f4_e4_LINK_ARGS_0);

/*
 * KEEP_CALL set for the "picked" function, so here is superfluous
 */
const struct e4_last_type _x1f4_e4_neon_3 = {
/* *INDENT-OFF* */
    "neon#3",
    neon_pick,
    0,
    NULL,
    1,
    KEEP_CALL | NEON_LINE | TEXT_LINK,
    6
/* *INDENT-ON* */
};

static int
neon_pick(x1f4_e4_LINK_ARGS_1)
{
    struct e4_post_type *post_data;
    unsigned neon;
    void **list, **used;

    neon = *(C_MODE *) context;
    used = input[-1];
    list = used[USED_LIST];

    post_data = (void *)
	((char *) output - offsetof(struct e4_post_type, data));

    /* required by e4.i._x1f4_e4_fast_miss.load_ever */
    fast_record(post_data, list[1 + neon]);
    miss_record(post_data);

    /* required */
    /* 3 is 2 for the current function (neon), plus 1 more for the result.
     * and what if this was not a function argument?
     */
    /* need this only for non reference parameters */
    list[-3] = line_record(post_data);

    return 0;
}
