/*
 * e4.a.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016, 2017, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4-defs.h>
#include <e4-types.h>

int
_x1f4_e4_ever_last(struct e4_atom_type *atom_data,
		   const struct e4_ever_type **ever)
{
    int delete;

    while (1) {
	int type;

	type = atom_data->type;
	if (type == EVER) {
	    *ever = atom_data->data.ever.ever_data;
	    delete = 1;
	    if (1) {
		break;
	    }
	} else {
	    if (type == THIS) {
		struct e4_hack_type *hack_data;

		hack_data = atom_data->data.hack.data;
		if (hack_data->count != 1) {
		    delete = 0;
		    if (1) {
			break;
		    }
		} else {
		    atom_data = hack_data->atom_data;
		}
	    } else {
		delete = 0;
		if (1) {
		    break;
		}
	    }
	}
    }

    return delete;
}
