/*
 * file.d.z.c
 * Copyright (C) 2008-2010, 2013, 2014, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>

#include <c-types.h>
#include <file-defs.h>
#include <file-types.h>

#define data(file, offset) \
    ((char *) (file(file) + 1) + (offset))

#define file(file) \
    ((struct eifile_type *) (file))

int
_libx1f4i0_msfn_ifile(void *file, C_BILL *msfn, unsigned size)
{
    int status;

    do {
	C_BILL bill = 0;
	int (*pull)(void *, void *, unsigned);
	unsigned ever, miss;
	void *sd;

	ever = file(file)->ever;

	miss = file(file)->size;
	if (1) {
	    unsigned char *data;

	    ever = file(file)->ever;

	    data = (void *) data(file, ever);

	    while (miss && size) {
		bill <<= 8;
		bill |= *data++;
		miss--;
		size--;
	    }

	    if (size) {
	    } else {
		file(file)->ever = ever + file(file)->size - miss;

		file(file)->size = miss;

		*msfn = bill;

		status = 0;

		break;
	    }
	}

	pull = file(file)->sf->pull;

	sd = &file(file)->sd;

	while (1) {
	    if (0) {
	    } else {
		status = pull(sd, file(file) + 1, EVER_MAX);
		if (status == -1) {
		    if (errno == EINTR) {
		    } else {
			status = READ_CLASS;
			if (1) {
			    break;
			}
		    }
		} else {
		    if (status) {
			unsigned char *data;

			data = (void *) (file(file) + 1);

			miss = status;

			while (miss && size) {
			    bill <<= 8;
			    bill |= *data++;
			    miss--;
			    size--;
			}

			if (size) {
			} else {
			    file(file)->ever = status - miss;

			    file(file)->size = miss;

			    *msfn = bill;

			    status = 0;

			    break;
			}
		    } else {
			status = OVER_CLASS;
			if (1) {
			    break;
			}
		    }
		}
	    }
	}
    } while (0);

    return status;
}
