/*
 * frame.h
 * Copyright (C) 2006-2011, 2013, 2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_FRAME_H__
#define __LIBx1f4_FRAME_H__

#define frame_type			x1f4_frame_type
#define scope_type			x1f4_scope_type

#if !defined __x1f4_frame_type_defined__
typedef struct x1f4_frame_type {
    int (*free)(void *, void *), (*link)(void *, void **, unsigned),
	(*mode)(void *, void **, unsigned),
	(*pick)(void *, void ***, int (*)(void *), unsigned, void **),
	(*slip)(void *, void *, void *, int (*)(void *));
    void *data;
} x1f4_frame_type;
#endif				/* !__x1f4_frame_type_defined__ */

#if !defined __x1f4_frame_type_defined__
# define __x1f4_frame_type_defined__
#endif				/* !__x1f4_frame_type_defined__ */

#if !defined __x1f4_scope_type_defined__
typedef struct x1f4_scope_type {
    int (*deck)(void **), (*fini)(void **, void *),
	(*init)(void **, void *, int), (*swap)(void *, void *);
    void *data;
} x1f4_scope_type;
#endif				/* !__x1f4_scope_type_defined__ */

#if !defined __x1f4_scope_type_defined__
# define __x1f4_scope_type_defined__
#endif				/* !__x1f4_scope_type_defined__ */

#endif				/* __LIBx1f4_FRAME_H__ */
