/*
 * lcardinal-d.c
 * Copyright (C) 2006-2007, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <limits.h>

int
x1f4_parse_dlcardinal(unsigned long *cardinal, const char *s, const char **e)
{
    int c, status = 0;

    c = *(const unsigned char *) s;
    if ('0' <= c && c <= '9') {
	unsigned long l = 0;

	do {
	    c -= '0';
	    if (l < ULONG_MAX / 10) {
		l *= 10;
		l += c;
	    } else {
		if (l ^ ULONG_MAX / 10) {
		    l = ULONG_MAX;
		} else {
		    l *= 10;
		    if (l < ULONG_MAX - c) {
			l += c;
		    } else {
			l = ULONG_MAX;
		    }
		}
	    }

	    s++;
	    c = *(const unsigned char *) s;
	} while ('0' <= c && c <= '9');

	status = c;

	*cardinal = l;
    } else {
	status = 1;
    }

    if (e) {
	*e = s;
    }

    return status;
}
