/*
 * lxcall-a.l.c
 * Copyright (C) 2011-2014, 2016, 2017, 2019, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcall-types.h>
#include <lxcast.h>

/*
 * coming in the wake of a _libx1f4i0_lxcall_long_call call, it expects
 * linetext_data->function set properly, bits include
 * X1f4_LXCALL_POST_LINE, etc.
 */
int
_libx1f4i0_lxcall_such_call(struct x1f4_linetext_type *linetext_data,
			    int name, unsigned mind, void *output,
			    struct center_type *center_data,
			    struct covert_type *covert_data, int lock,
			    const int *hold, struct fxdata_type *fxdata_data,
			    struct x1f4_dxcast_type *dxcast_data)
{
    int status;
    void **track;

    track = *center_data->input;

    do {
	if (covert_data->swap) {
	    status = covert_data->scope_data->deck
		(&covert_data->frame_data->data);
	    if (status) {
		break;
	    }
	}

	status = _libx1f4i0_lxcall_even_ware
	    (center_data, name, mind, lock, hold, fxdata_data, dxcast_data);
	if (status) {
	    break;
	}

	((void **) track[-1])[X1f4_E4_RENDITION] = &linetext_data->function;

	status = linetext_data->function.function
	    ((void *) linetext_data->context, output, track);
    } while (0);

    return status;
}
