/*
 * lxcall-a.n.c
 * Copyright (C) 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <frame.h>
#include <lxcall-inter.h>
#include <lxcall-types.h>

int
_libx1f4i0_lxcall_mint_call(struct covert_type *covert_data,
			    struct x1f4_track_type *track_data)
{
    int status;
    struct x1f4_scope_type *scope_data;

    scope_data = covert_data->scope_data;

    status = scope_data->init(&covert_data->swap, scope_data->data, 0);
    if (status) {
    } else {
	status = scope_data->swap
	    (covert_data->swap, covert_data->frame_data->data);
	if (status) {
	    scope_data->fini(&covert_data->swap, scope_data->data);
	    covert_data->swap = NULL;
	}
    }
    if (status) {
	status = _libx1f4i0_lxcall_stat_link(track_data);
    }

    return status;
}
