/*
 * lxcall-o.o.c
 * Copyright (C) 2017-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <e4.h>
#include <integral_q.h>
#include <lxfset.h>
#include <trans.h>

int
x1f4_suit_prefix(void *iran, int type, const char *name, unsigned size,
		 void *trans)
{
    int status;
    void *post, *record;

    post = (void *) (integral_q) type;
    status = x1f4_post_lxfset(iran, (void *) &post, &record);
    if (status) {
	if (status ^ X1f4_BQFSET_EVER_MATCH) {
	} else {
	    /* not an error.  should do something here. */
	}
    } else {
	struct x1f4_trans_type *trans_data;
	void **line;

	trans_data = trans;

	line = record;

	status = trans_data->link
	    (trans_data->data, line + 1, sizeof(x1f4_deprefix_type) << 1);
	if (status) {
	} else {
	    struct x1f4_deprefix_type *deprefix_data;

	    line[0] = (void *) (integral_q) type;

	    deprefix_data = line[1];

	    deprefix_data->name = name;
	    deprefix_data->size = size;
	    deprefix_data++;
	    deprefix_data->name = NULL;
	    deprefix_data->size = 0;
	}
    }

    return status;
}

