/*
 * lxcase-c.j.c
 * Copyright (C) 2016, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>

#include <e4.h>
#include <lxcall.h>
#include <lxcase-drive.h>
#include <lxcase-inter.h>
#include <lxcase-types.h>

int
_libx1f4i0_lxcase_i241108_0(void *context, void *output, void **input)
{
    char *renv;
    int status;

    renv = getenv(I_TEXT(input[1]));
    if (renv) {
	status = _libx1f4i0_lxcall_swap_text
	    (&((struct lxcase_type *) context)->ever_a, *input, renv,
	     strlen(renv) + 1);
	if (status) {
	} else {
	    l_TEXT(I_TEXT(*input), output);
	}

	l_MODE(1, output);
    } else {
	status = 0;
	l_MODE(0, output);
    }

    return status;
}
