/*
 * lxcase-d.0.c
 * Copyright (C) 2016, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>

#include <sys/stat.h>
#include <sys/types.h>

#include <e4.h>
#include <lxcase-drive.h>
#include <lxcase-inter.h>
#include <lxcase-types.h>

int
_libx1f4i0_lxcase_i241109_0(void *context, void *output, void **input)
{
    int status;

    status = mkdir(I_TEXT(input[0]), I_MODE(input[1]));
    if (status) {
	if (errno == EEXIST) {
	    status = 0;
	} else {
	    status = _libx1f4i0_lxcase_stat_case
		(context, "create directory", I_TEXT(input[0]),
		 I_MODE(input[1]));
	}
    }

    return status;
}
