/*
 * lxcast-i.y.c
 * Copyright (C) 2010, 2011, 2013, 2014, 2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxcast-inter.h>
#include <lxcast-types.h>

#define I_CAST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define dxcast(cast) \
    ((struct dxcast_type *) (cast))

int
_libx1f4i0_lxcast_y_indexed(void *context, void *output, void **input)
{
    int name, status, type;
    struct dxcast_type *dxcast_data;
    struct lxcast_type *lxcast_data;
    struct lxtext_type *lxtext_data;

    dxcast_data = I_CAST(input[1]);

    lxtext_data = context;

    lxcast_data = lxtext_data->text;

    name = dxcast_data->type;

    type = lxtext_data->nodetype.code;

    if (name != type) {
	do {
            struct x1f4_composer_type *composer_data;

            composer_data = &lxcast_data->link_q;
            if (composer_data->link) {
                const struct x1f4_linetext_type *linetext_data;

                status = composer_data->link
                    (composer_data->text, type, name, &linetext_data);
                if (status) {
                } else {
                    void *track;

                    track = &dxcast_data->data;
                    status = linetext_data->function.function
                        ((void *) linetext_data->context, output, &track);
                    if (status) {
                    } else {
			status = _libx1f4i0_lxcall_rule_node
			    (&lxcast_data->link_v, &lxcast_data->link_e,
			     &lxtext_data->nodetype, I_USER(output), *input);
                    }

		    break;
                }
            }

	    status = _libx1f4i0_lxcast_stat_luck(lxcast_data, 1, name, type);
	} while (0);
    } else {
	status = _libx1f4i0_lxcall_rule_node
	    (&lxcast_data->link_v, &lxcast_data->link_e,
	     &lxtext_data->nodetype, I_USER(&dxcast_data->data), *input);
	if (status) {
	} else {
	    l_USER(I_USER(*input), output);
	}
    }

    return status;
}
