/*
 * lxdash-a.s.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

extern const struct x1f4_bqnorm_type _libx1f4i0_lxdash_u_norm;

int
_libx1f4i0_lxdash_fast_line(void *lxdash, void *dxdash)
{
    int status;
    struct lxdash_type *lxdash_data;
    struct _libx1f4i0_bqfset_type bqfset;

    lxdash_data = lxdash;

    bqfset.fare = _libx1f4i0_lxdash_u_norm.fare;
    bqfset.look = _libx1f4i0_lxdash_u_norm.look;
    bqfset.move = _libx1f4i0_lxdash_u_norm.move;
    bqfset.pick = _libx1f4i0_lxdash_u_norm.pick;

    bqfset.trans = &lxdash_data->link_m;

    bqfset.size = sizeof(struct effect_type);

    ((struct dxdash_type *) dxdash)->dash = post_dxdash(dxdash);

    status = _libx1f4i0_fast_lxfset
	(((struct dxdash_type *) dxdash)->dash,
	 X1f4_BQFSET_SIZE_FRAME | X1f4_BQFSET_TRANS_MASK, &bqfset);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
    }

    return status;
}
