/*
 * lxdash-b.e-c.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdash-config.h>

#include <d_fset.h>
#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

extern const struct x1f4_bqnorm_type _libx1f4i0_lxdash_u_norm,
    _libx1f4i0_lxdash_z_norm;

int
_libx1f4i0_lxdash_e_press_b(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *dash;
#if __CLIP_EXTRACT__
#else
    void *data;
#endif				/* __CLIP_EXTRACT__ */

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    dxdash_data = I_LINE(input[1]);

    dash = dxdash_data->dash;

    effect.mode = I_MODE(input[2]);
    effect.type = X1f4_E4_BILL;

#if __CLIP_EXTRACT__
    _libx1f4i0_norm_lxfset(dash, &_libx1f4i0_lxdash_z_norm);
    status = _libx1f4i0_cast_lxfset(dash, &effect);
    _libx1f4i0_norm_lxfset(dash, &_libx1f4i0_lxdash_u_norm);
    if (status) {
	if (status == X1f4_BQFSET_MISS_CLASS) {
	    if (effect.type ^ X1f4_E4_BILL) {
		status = _libx1f4i0_lxdash_stat_type
		    (lxdash_data, effect.mode, effect.type, X1f4_E4_BILL);
	    } else {
		status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
	    }
	} else {
	    status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
	}
    } else {
	X1f4_E4_C_BILL fast;

	dxdash_data->size--;

	switch (effect.type) {
	case X1f4_E4_BILL:
	    fast = I_BILL(&effect.fxdata);
	    break;
	case X1f4_E4_MODE:
	    fast = I_MODE(&effect.fxdata);
	    break;
	default:
	    fast = I_REAL(&effect.fxdata);
	}

	l_BILL(fast, output);
	l_BILL(fast, input[0]);
    }
#else
    status = x1f4_find_lxfset(dash, &effect, &data);
    if (status) {
	X1f4_E4_C_BILL fast;
	struct effect_type *effect_data;
	unsigned type;

	status = 0;

	effect_data = data;

	type = effect_data->type;
	switch (type) {
	case X1f4_E4_BILL:
	    fast = I_BILL(&effect_data->fxdata);
	    break;
	case X1f4_E4_MODE:
	    fast = I_MODE(&effect_data->fxdata);
	    break;
	case X1f4_E4_REAL:
	    fast = I_REAL(&effect_data->fxdata);
	    break;
	default:
	    fast = 0;
	    status = _libx1f4i0_lxdash_stat_type
		(lxtext_data->text, effect.mode, type, X1f4_E4_BILL);
	}

	if (status) {
	} else {
	    status = _libx1f4i0_cast_lxfset(dash, &effect);
	    if (status) {
		status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
	    } else {
		dxdash_data->size--;

		if (0) {
		} else {
		    l_BILL(fast, output);
		    l_BILL(fast, input[0]);
		}
	    }
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }
#endif				/* __CLIP_EXTRACT__ */

    return status;
}
