/*
 * lxdash-b.f.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_f_class_b(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data, *lxtext_link;
    void *data;

    dxdash_data = I_LINE(input[0]);

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    effect.mode = I_MODE(input[1]);

    status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);

    do {
	struct effect_type *effect_data;

	effect_data = data;

	lxtext_link = lxdash_data->link_f.text;

	if (status) {
	    if (status ^ X1f4_BQFSET_EVER_MATCH) {
		status =
		    _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);

		break;
	    } else {
		unsigned link;

		status = 0;

		link = effect_data->link;

		if (~link) {
		    int (*free)(void *, void *, struct excase_type **,
				const struct excase_type *);
		    struct lxtext_type *lxtext_slip;

		    lxtext_slip = lxtext_link + link;

		    free = lxtext_slip->lxtype.free;
		    if (free) {
			status = free
			    (lxtext_slip->lxtype.context,
			     I_USER(&effect_data->fxdata), NULL,
			     lock_excase(dxdash_data));
			if (status) {
			    if (1) {
				break;
			    }
			}
		    }
		}
	    }
	} else {
	    dxdash_data->size++;

	    effect_data->mode = effect.mode;
	}

	{
	    X1f4_E4_C_BILL trip;
    
	    effect_data->type = X1f4_E4_BILL;

	    effect_data->link = ~0;

	    trip = I_BILL(input[2]);

	    l_BILL(trip, &effect_data->fxdata);
	    l_BILL(trip, output);
	}
    } while (0);

    return status;
}
