/*
 * lxdash-l.j.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <d_fset.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_j_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data, *dxdash_text;

    dxdash_data = I_LINE(input[0]);
    dxdash_text = I_LINE(input[1]);

    do {
	void *ever, *lead, *way_red[4];

	if (dxdash_data == dxdash_text) {
	    status = 0;
	    break;
	}
	status = _libx1f4i0_lead_lxfset(dxdash_text->dash, &lead);
	if (status) {
	    if (status == X1f4_BQFSET_DECK_ERROR) {
	    } else {
		status = _libx1f4i0_lxdash_stat_line(context, 0, status);
		break;
	    }
	} else {
	    status = _libx1f4i0_ever_lxfset(dxdash_data->dash, &ever);
	    if (status) {
		if (status == X1f4_BQFSET_DECK_ERROR) {
		} else {
		    status = _libx1f4i0_lxdash_stat_line(context, 0, status);
		    break;
		}
	    } else {
		if (((struct effect_type *) ever)->mode
		    < ((struct effect_type *) lead)->mode) {
		} else {
		    status = _libx1f4i0_lxdash_stat_join(context);
		    break;
		}
	    }
	}

	way_red[1] = context;
	way_red[2] = lock_excase(dxdash_text);
	way_red[3] = lock_excase(dxdash_data);

	status = _libx1f4i0_lime_lxfset
	    (dxdash_text->dash, way_red, _libx1f4i0_lxdash_move_dash);
	if (status) {
	} else {
	    status = _libx1f4i0_join_lxfset
		(dxdash_data->dash, dxdash_text->dash);
	    if (status) {
	    } else {
		dxdash_data->size += dxdash_text->size;
		dxdash_text->size = 0;
	    }
	}
    } while (0);

    if (status) {
    } else {
	l_LINE(dxdash_data, output);
    }

    return status;
}
