/*
 * lxdash-v.a.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_a_class_v(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data, *slip;

    lxtext_data = context;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = lxtext_data->text;

    status = lxtext_data->lxtype.copy
	(lxtext_data->lxtype.context, NULL, &slip,
	 I_USER(input[2]), lock_excase(dxdash_data));
    if (status) {
    } else {
	if (0) {
	} else {
	    effect.mode = I_MODE(input[1]);

	    status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	    if (status) {
		int excess;

		if (status == X1f4_BQFSET_EVER_MATCH) {
		    status = 0;
		} else {
		    status = _libx1f4i0_lxdash_stat_text
			(lxtext_data->text, status, effect.mode);
		}

		excess = lxtext_data->lxtype.free
		    (lxtext_data->lxtype.context, slip, NULL,
		     lock_excase(dxdash_data));
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    } else {
		struct effect_type *effect_data;
		unsigned link, type;

		effect_data = data;

		type = lxtext_data->lxtype.code;

		effect_data->type = type;

		effect_data->mode = effect.mode;

		link = lxtext_data
		    - ((struct lxtext_type *) lxdash_data->link_f.text);

		effect_data->link = link;

		dxdash_data->size++;

		l_USER(slip, &effect_data->fxdata);
	    }
	}
    }

    return status;
}
