/*
 * lxdata-e.t.c
 * Copyright (C) 2010-2011, 2016, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <dt.h>
#include <ix.h>
#include <lxdata-inter.h>
#include <mxdeck.h>

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

int
x1f4_wrap_lxdata(void *lxdata, struct x1f4_indexset_type *indexset_data)
{
    const char *name;
    const struct x1f4_datatype_type *datatype_data;

    datatype_data = indexset_data->datatype_set.datatype_data;

    name = datatype_data->name;
    while (name) {
	if (datatype_data->size == 4) {
	    int a, b, c, d;

	    a = name[0];
	    b = name[1];
	    c = name[2];
	    d = name[3];

	    if (a == 'f' && b == 'i' && c == 'l' && d == 'e') {
		lxdata(lxdata)->link_l.file = datatype_data->context;
#if 0
		lxdata(lxdata)->link_y.nodetype[0].context =
		    datatype_data->context;
#endif				/* 0 */
	    }
	}

	datatype_data++;

	name = datatype_data->name;
    }

    if (x1f4_find_mxpath
	(indexset_data->function_set.text, "f_b_affix", 9,
	 &lxdata(lxdata)->rule_l.f_b_affix)) {
    } else {
	lxdata(lxdata)->rule_l.f_b_affix = NULL;
    }

    return 0;
}
