/*
 * lxdata-f.m.c
 * Copyright (C) 2008-2014, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_m_forward(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_BILL hold = 0;
	X1f4_E4_C_MODE mode;
	int c;
	struct dxdata_type *dxdata_data;
	unsigned size;
	unsigned char *data, *lead;

	dxdata_data = I_DATA(input[0]);

	mode = I_MODE(input[1]);

	size = dxdata_data->length;

	size++;
	if (mode < 0) {
	    if ((X1f4_E4_C_MODE) size < -mode) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -mode);
		if (1) {
		    break;
		}
	    } else {
		mode = size + mode;
	    }
	} else {
	    if (mode < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, mode);
		if (1) {
		    break;
		}
	    }
	}

	status = 0;

	lead = (void *) dxdata_data->string;

	data = lead + mode;

	do {
	    c = *data++;
	    hold <<= 7;
	    hold |= c & 127;
	} while (c & 128);

	mode = data - lead;

	if (mode == size) {
	    status = _libx1f4i0_lxdata_stat_hang(context);
	    if (1) {
		break;
	    }
	}

	l_BILL(hold, output);

	l_MODE(mode, input[1]);
    } while (0);

    return status;
}
