/*
 * lxdata-i.p.c
 * Copyright (C) 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

#define dxdata(dxdata) \
    ((struct dxdata_type *) (dxdata))

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdata_part_data(void *lxdata, void *dxdata, unsigned rate)
{
    int status;

    if (rate) {
	unsigned call, copy, size;

	size = dxdata(dxdata)->length;

	if (rate < 16) {
	    copy = 16;
	} else {
	    text_size(copy, rate);
	}
	if (size < 16) {
	    call = 16;
	} else {
	    text_size(call, size);
	}
	if (copy ^ call) {
	    void *text;

	    text = dxdata(dxdata)->string;

	    status = lxdata(lxdata)->link_m.mode
		(lxdata(lxdata)->link_m.data, &text, copy + 1);
	    if (status) {
		status = _libx1f4i0_lxdata_stat_mode(lxdata);
	    } else {
		dxdata(dxdata)->length = rate;
		dxdata(dxdata)->string = text;
	    }
	} else {
	    status = 0;

	    dxdata(dxdata)->length = rate;
	}
    } else {
	status = lxdata(lxdata)->link_m.free
	    (lxdata(lxdata)->link_m.data, dxdata(dxdata)->string);
	if (status) {
	    status = _libx1f4i0_lxdata_stat_free(lxdata, 0);
	} else {
	    dxdata(dxdata)->length = 0;
	    dxdata(dxdata)->string = (char *) x1f4_c1_empty_string;
	}
    }

    return status;
}
