/*
 * lxdata-n.c.c
 * Copyright (C) 2008-2014, 2018, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcast.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_c_nearest(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE mode;
	int type;
	struct dxdata_type *dxdata_data;
	struct x1f4_dxcast_type *dxcast_data;
	unsigned size;

	dxcast_data = I_USER(input[1]);
	type = dxcast_data->type;
	if (type == X1f4_E4_BILL || type == X1f4_E4_MODE) {
	    mode = I_MODE(&dxcast_data->data);
	} else {
	    status = _libx1f4i0_lxdata_stat_pick(context, type);
	    if (1) {
		break;
	    }
	}

	dxdata_data = I_DATA(input[0]);

	size = dxdata_data->length;

	if (mode < 0) {
	    if ((X1f4_E4_C_MODE) size < -mode) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, mode);
		if (1) {
		    break;
		}
	    } else {
		mode = size + mode;
	    }
	} else {
	    if (mode < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, mode);
		if (1) {
		    break;
		}
	    }
	}

	status = 0;

	l_MODE(((unsigned char *) dxdata_data->string)[mode], output);
    } while (0);

    return status;
}
