/*
 * lxdata-i.g.c
 * Copyright (C) 2009, 2010, 2013, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-inter.h>
#include <lxdata-types.h>

static int free_data(void *, void *);
static int link_data(void *, void **, unsigned);

static int
free_data(void *context, void *data)
{
    struct transd_type *transd_data;

    transd_data = context;

    return _libx1f4i0_lxdata_kate_data
	(transd_data->lxdata, transd_data->dxdata_data, 0, 0);
}


static int
link_data(void *context, void **link, unsigned size)
{
    int status;
    struct transd_type *transd_data;

    transd_data = context;

    status = _libx1f4i0_lxdata_kate_data
	(transd_data->lxdata, transd_data->dxdata_data, 0, size);
    if (status) {
    } else {
	*link = transd_data->dxdata_data->string;
    }

    return status;
}


int
x1f4_mold_lxdata(void *lxdata, struct transd_type *transd_data)
{
    transd_data->transa.data = transd_data;
    transd_data->lxdata = lxdata;

    transd_data->transa.free = free_data;
    transd_data->transa.link = link_data;
    transd_data->transa.mode = link_data;

    return 0;
}
