/*
 * lxdate-l.a.c
 * Copyright (C) 2008-2014, 2018, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <time.h>

#include <e4.h>
#include <lxdate-drive.h>
#include <lxdate-inter.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxdate_a_logique(void *context, void *output, void **input)
{
    struct dxdate_type *dxdate_data;
    struct dxtime_type *dxtime_data;
    time_t second_a;
    unsigned second_f;

    dxdate_data = I_DATE(input[0]);

    dxtime_data = I_TIME(input[1]);

    second_a = dxdate_data->time;
    second_f = dxdate_data->second_f;

    if (dxtime_data->second_l & 1 << 17) {
	second_a -= dxtime_data->second_a;

	second_f -= dxtime_data->second_f;
	if ((int) second_f < 0) {
	    second_a--;
	    second_f += 1000000;
	}
    } else {
	second_a += dxtime_data->second_a;

	second_f += dxtime_data->second_f;
	if (second_f < 1000000) {
	} else {
	    second_a++;
	    second_f -= 1000000;
	}
    }

    _libx1f4i0_lxdate_sink_date(dxdate_data, second_a, second_f);

    l_DATE(dxdate_data, output);

    return 0;
}
