/*
 * lxdate-p.n.c
 * Copyright (C) 2016, 2018-2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <sys/time.h>

#include <lxcall.h>
#include <lxdate-drive.h>
#include <lxdate-inter.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxdate_n_pending(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_lxdate(context, &data);
    if (status) {
    } else {
	struct lxdate_type *lxdate_data;

	lxdate_data = context;

	status = x1f4_raft_node
	    (&lxdate_data->link_v, &lxdate_data->link_e,
	     lxdate_data->link_t.datatype + 0, data);
	if (status) {
	    _libx1f4i0_lxdate_slip_date(context, &data);
	} else {
	    struct timeval current_time;

	    l_DATE(data, output);

	    gettimeofday(&current_time, NULL);

	    x1f4_sink_lxdate(data, current_time.tv_sec, current_time.tv_usec);
	}
    }

    return status;
}

