/*
 * lxdate-x.i.c
 * Copyright (C) 2008, 2009, 2013, 2014, 2018, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <time.h>

#include <lxdate-drive.h>
#include <lxdate-types.h>

int
x1f4_sink_lxdate(struct dxdate_type *dxdate_data, time_t second_a,
		 unsigned window_f)
{
    struct tm down_time;

    dxdate_data->time = second_a;

    dxdate_data->second_f = window_f;

    localtime_r(&second_a, &down_time);

    dxdate_data->second_i = b6(down_time.tm_sec) | b6(down_time.tm_min) << 6
	| b5(down_time.tm_hour) << 12 | b5(down_time.tm_mday) << 17
	| b4(down_time.tm_mon) << 22;
    dxdate_data->second_l = b3(down_time.tm_wday)
	| b9(down_time.tm_yday) << 3 | down_time.tm_year << 12;

    return 0;
}
