/*
 * lxdecq-k.j.s.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016-2018, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_jskeeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    void *data;

    cxbend_data = context;

    lxdecq_data = cxbend_data->list;

    dxlist_data = I_LIST(input[1]);

    status = cxbend_data->pick(dxlist_data->list, &data);
    if (status) {
	if (status == X1f4_DLLIST_DECK_ERROR) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
	}
    } else {
	unsigned call, type;

	type = effect_type(data);
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    l_MODE(0, output);
	} else {
	    unsigned link;

	    l_MODE(1, output);

	    link = effect_link(data);

	    do {
		if (~link) {
		    struct lxtext_type *lxtext_data;

		    lxtext_data = lxdecq_data->link_f.text;
		    lxtext_data += link;
		    if (lxtext_data->lxtype.lead && lxtext_data->lxtype.slip) {
			status = _libx1f4i0_lxcall_land_node
			    (&lxdecq_data->link_v, &lxdecq_data->link_e,
			     &lxtext_data->lxtype, E_USER(data), input[0]);
			if (1) {
			    break;
			}
		    }

		    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
			status = _libx1f4i0_lxcall_side_node
			    (&lxtext_data->lxtype, E_USER(data), input[0]);
			if (1) {
			    break;
			}
		    }
		}

		copy_miss(*input, type, effect_data(data));
	    } while (0);
	    if (status) {
	    } else {
		status = cxbend_data->roll(dxlist_data->list);
		if (status) {
		    status = _libx1f4i0_lxdecq_stat_list
			(lxdecq_data, 0, status);
		}
	    }
	}
    }

    return status;
}

