/*
 * lxfile-f.m.c
 * Copyright (C) 2008, 2009, 2010, 2013, 2016, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

int
_libx1f4i0_lxfile_m_forward(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxfile_type *dxfile_data;
	unsigned pull;

	dxfile_data = I_FILE(input[0]);

	if (dxfile_data->mode != READ_CLASS) {
	    status = _libx1f4i0_lxfile_stat_turn(context, dxfile_data);
	    if (1) {
		break;
	    }
	}

	status = _libx1f4i0_mfvn_ifile(dxfile_data->file, output, &pull);
	if (status) {
	    status = _libx1f4i0_lxfile_stat_file(context, status);
	}
    } while (0);

    return status;
}
