/*
 * lxfile-s.l.c
 * Copyright (C) 2008, 2009, 2010, 2013, 2020-2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1.h>
#include <e4.h>
#include <file.h>
#include <lxdata.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>
#include <trans.h>

int
_libx1f4i0_lxfile_l_sequent(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxfile_type *dxfile_data;
	struct lxfile_type *lxfile_data;
	void *file;

	dxfile_data = I_FILE(input[0]);

	lxfile_data = context;

	file = dxfile_data->file;
	if (1) {
	    struct x1f4_transd_type transd;
	    struct x1f4_dxdata_type *dxdata_data;
	    unsigned size;
	    void *data;

	    if (dxfile_data->mode != READ_CLASS) {
		status = _libx1f4i0_lxfile_stat_turn(lxfile_data, dxfile_data);
		if (1) {
		    break;
		}
	    }

	    x1f4_mold_lxdata(lxfile_data->link_l.data, &transd);

	    dxdata_data = I_DATA(input[1]);

	    transd.dxdata = dxdata_data;

	    data = dxdata_data->string;
	    size = dxdata_data->length;

	    status = _libx1f4i0_line_ifile(file, &data, &size, &transd.transa);
	    if (status) {
		if (status == FILE_OVER_CLASS) {
		    l_MODE(-1, output);

		    status = x1f4_kate_lxdata
			(lxfile_data->link_l.data, dxdata_data, 1, 0);
		} else {
		    status = _libx1f4i0_lxfile_stat_file(lxfile_data, status);
		}
	    } else {
		l_MODE(size, output);

		dxdata_data->length = size;
		dxdata_data->string = data;
	    }
	}
    } while (0);

    return status;
}

