/*
 * lxline-b.1-c.s.c
 * Copyright (C) 2008-2015, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxdata.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_1_order_b(void *context, void *output, void **input)
{
    int status;
    const char *lift;
    struct cxseek_type *cxseek_data;
    struct dxline_type *dxline_data;
    struct x1f4_dxdata_type *dxdata_data;
    unsigned size;
    void *data;

    cxseek_data = context;

    dxline_data = I_LINE(input[1]);

    dxdata_data = I_DATA(input[2]);

    status = cxseek_data->seek
	(dxline_data->line, dxdata_data->string, &data, &lift, &size);
    if (status) {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_BILL) {
	    status = _libx1f4i0_lxline_stat_trip
		(cxseek_data->line, lift, size, type, X1f4_E4_BILL);
	} else {
	    struct lxline_type *lxline_data;

	    lxline_data = cxseek_data->line;

	    status = x1f4_kate_lxdata
		(lxline_data->link_l.data, dxdata_data, 1, size);
	    if (status) {
	    } else {
		memcpy(dxdata_data->string, lift, size);

		l_BILL(E_BILL(data), input[0]);
		l_MODE(1, output);
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
