/*
 * lxline-b.j.c
 * Copyright (C) 2008-2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-types.h>

#define dxline(line) \
    ((struct dxline_type *) (line))

int
_libx1f4i0_lxline_j_class_b(void *context, void *output, void **input)
{
    int delete;
    void *data;

    delete = _libx1f4i0_find_sfnote
	(dxline(I_LINE(input[1]))->line, I_TEXT(input[2]), &data);
    if (delete) {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_BILL) {
	    l_MODE(0, output);
	} else {
	    l_MODE(1, output);

	    l_BILL(E_BILL(data), input[0]);
	}
    } else {
	l_MODE(0, output);
    }

    return 0;
}
