/*
 * lxline-l.m.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_m_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    fail = I_TEXT(input[1]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	X1f4_E4_C_TEXT land;
	void *text;

	land = I_TEXT(input[2]);

	status = _libx1f4i0_post_sfnote
	    (dxline_data->line, land, effect_size, &text);
	if (status) {
	    do {
		if (status == X1f4_SFNOTE_EVER_MATCH) {
		    int c, e;

		    do {
			c = *fail++;
			e = c ^ *land++;
			if (e) {
			    break;
			}
		    } while (c);

		    if (e) {
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		}

		status = _libx1f4i0_lxline_stat_text
		    (lxline_data, status, I_TEXT(input[2]));
	    } while (0);
	} else {
	    struct fxdata_type *fxdata_data;

	    link_effect(text, effect_link(data));
	    type_effect(text, effect_type(data));

	    fxdata_data = (void *) effect_data(text);

	    *fxdata_data = *(struct fxdata_type *) effect_data(data);

	    link_effect(data, ~0);

	    status = _libx1f4i0_pass_sfnote(dxline_data->line, fail);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	    }
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
