/*
 * lxline-p.n.c
 * Copyright (C) 2008-2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define dxline(line) \
    ((struct dxline_type *) (line))

int
_libx1f4i0_lxline_n_pending(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_TEXT fail;
	struct lxline_type *lxline_data;
	void *data;

	lxline_data = context;

	fail = I_TEXT(input[1]);

	status = _libx1f4i0_find_sfnote
	    (dxline(I_LINE(input[0]))->line, fail, &data);
	if (status) {
	    unsigned type;

	    type = effect_type(data);
	    if (type != X1f4_E4_TEXT) {
		status = 0;
	    } else {
		const char *lift;

		lift = E_TEXT(data);
		status = x1f4_auto_text
		    (&lxline_data->link_v, &lxline_data->link_e, lift,
		     strlen(lift), output);

		break;
	    }
	}

	l_TEXT(fail, output);
    } while (0);

    return status;
}
