/*
 * lxline-r.g-c.c
 * Copyright (C) 2008-2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_i_class_r(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[1]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[2]), &data);
    if (status) {
	X1f4_E4_C_REAL real;
	unsigned type;

	status = 0;

	type = effect_type(data);
	switch (type) {
	case X1f4_E4_BILL:
	    real = E_BILL(data);
	    break;
	case X1f4_E4_MODE:
	    real = E_MODE(data);
	    break;
	case X1f4_E4_REAL:
	    real = E_REAL(data);
	    break;
	default:
	    real = 0;
	    status = _libx1f4i0_lxline_stat_type
		(lxtext_data->text, I_TEXT(input[2]), type, X1f4_E4_REAL);
	}

	if (status) {
	} else {
	    l_REAL(real, input[0]);
	    l_REAL(real, output);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss
	    (lxtext_data->text, I_TEXT(input[2]));
    }

    return status;
}
