/*
 * lxline-u.0-s.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_0_point_u(void *context, void *output, void **input,
			    int (*seek)(void *, const char *, void **,
					const char **, unsigned *))
{
    int status;
    const char *lift;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    unsigned size;
    void *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[1]);

    lxline_data = lxtext_data->text;

    status = seek(dxline_data->line, I_TEXT(input[2]), &data, &lift, &size);
    if (status) {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxline_stat_trip
		(lxtext_data->text, lift, size, type,
		 lxtext_data->lxtype.code);
	} else {
	    status = _libx1f4i0_lxcall_swap_text
		(&lxline_data->ever_a, input[3], (void *) lift, size + 1);
	    if (status) {
	    } else {
		X1f4_E4_C_USER user;

		user = E_USER(data);
		if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		    status = _libx1f4i0_lxcall_side_node
			(&lxtext_data->lxtype, user, input[0]);
		    if (status) {
		    } else {
			l_MODE(1, output);
		    }
		} else {
		    l_USER(user, input[0]);
		    l_MODE(1, output);
		}
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
