/*
 * lxline-v.g-c.c
 * Copyright (C) 2008-2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_note.h>
#include <lxrail.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_i_class_v(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    dxline_data = I_LINE(input[1]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[2]), &data);
    if (status) {
	int name, type;

	name = lxtext_data->lxtype.code;
	type = effect_type(data);

	status = _libx1f4i0_lxrail_rank_node
	    (__types_rail(lxline_data), lxtext_data, name, &type,
	     effect_data(data), output, input);
	if (type != name) {
	    status = _libx1f4i0_lxline_stat_type
		(lxline_data, I_TEXT(input[2]), type, name);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, I_TEXT(input[2]));
    }

    return status;
}

