/*
 * lxlist-l.s.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_s_logique(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;

    dxlist_data = I_LIST(input[0]);
    if (0) {
    } else {
	X1f4_E4_C_MODE delete;
	unsigned size;

	delete = I_MODE(input[1]);

	size = dxlist_data->size;
	if (delete < -(X1f4_E4_C_MODE) (int) size
	    || !(delete < (X1f4_E4_C_MODE) (int) size)) {
	    status = _libx1f4i0_lxlist_stat_deck(context, size, delete);
	} else {
	    X1f4_E4_C_MODE insert;

	    insert = I_MODE(input[2]);

	    if (insert < -(X1f4_E4_C_MODE) (int) size
		|| !(insert < (X1f4_E4_C_MODE) (int) size)) {
		status = _libx1f4i0_lxlist_stat_deck(context, size, insert);
	    } else {
		void *data;

		if (insert < 0) {
		    insert += size;
		}

		if (delete < 0) {
		    delete += size;
		}

		status = _libx1f4i0_peek_l4list
		    (dxlist_data->list, delete, &data);
		if (status) {
		    status = _libx1f4i0_lxlist_stat_list(context, 0, status);
		} else {
		    void *text;

		    status = _libx1f4i0_peek_l4list
			(dxlist_data->list, insert, &text);
		    if (status) {
			status = _libx1f4i0_lxlist_stat_list
			    (context, 0, status);
		    } else {
			int trip;
			struct fxdata_type fxdata;

			trip = effect_type(data);
			type_effect(data, effect_type(text));
			type_effect(text, trip);
			trip = effect_link(data);
			link_effect(data, effect_link(text));
			link_effect(text, trip);

			fxdata = *(struct fxdata_type *) effect_data(data);
			*(struct fxdata_type *) effect_data(data) =
			    *(struct fxdata_type *) effect_data(text);
			*(struct fxdata_type *) effect_data(text) = fxdata;

			l_LIST(dxlist_data, output);
		    }
		}
	    }
	}
    }

    return status;
}
