/*
 * lxlist-p.q.c
 * Copyright (C) 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcast.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_q_pending(void *context, void *output, void **input)
{
    int status, type;
    struct x1f4_dxcast_type *dxcast_data;
    void *track[2];

    dxcast_data = I_USER(input[1]);
    type = dxcast_data->type;
    switch (type) {
    case X1f4_E4_BILL:
    case X1f4_E4_MODE:
	track[0] = input[0];
	track[1] = &dxcast_data->data;
	status = _libx1f4i0_lxlist_q_forward(context, output, track);
	break;
    default:
	status = _libx1f4i0_lxlist_stat_pick(context, type);
    }

    return status;
}

