/*
 * lxlist-u.q.f.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxlist_qfclass_u(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    void *data;

    dxlist_data = I_LIST(input[0]);

    status = _libx1f4i0_lead_l4list(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxlist_stat_list
	    (lxtext(context)->text, 0, status);
    } else {
	struct lxtext_type *lxtext_data;
	unsigned type;

	lxtext_data = context;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxlist_stat_type
		(lxtext_data->text, 0, type, lxtext_data->lxtype.code);
	} else {
	    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		status = _libx1f4i0_lxcall_pass_node
		    (&lxtext_data->lxtype, E_USER(data),
		     output);
	    } else {
		l_USER(E_USER(data), output);
	    }
	}
    }

    return status;
}

