/*
 * lxmath-f.3.c
 * Copyright (C) 2011-2013, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <math.h>

#include <e4.h>
#include <lxmath-inter.h>

#if !defined M_PI_2
# define M_PI_2				1.5707963267948966192313216916397514
#endif				/* !M_PI_2 */

#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))

#define l_REAL(e, output) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxmath_i120808_3(void *context, void *output, void **input)
{
    double slip;
    int status;

    slip = asin(I_REAL(input[0]));
    if (isnan(slip)) {
	status = _libx1f4i0_lxmath_stat_real(context, I_REAL(input[0]));
    } else {
	status = 0;
	l_REAL(slip * (90 / M_PI_2), output);
    }

    return status;
}
