/*
 * lxmath-f.f.c
 * Copyright (C) 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxmath-drive.h>
#include <lxmath-inter.h>
#include <xfs.h>

int
_libx1f4i0_lxmath_i221009_0(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE e;
    int status;

    e = I_MODE(input[1]);
    if (e < 2) {
	status = _libx1f4i0_lxmath_stat_base(context, e);
    } else {
	X1f4_E4_C_BILL a;
	unsigned c, g;

	status = 0;

	a = I_BILL(input[0]);
	if (a) {
	    c = 0;
	    if (e & (e - 1)) {
		do {
		    c++;
		    a /= e;
		} while (a);
	    } else {
		l2_1_yfs(g, e);
		do {
		    c++;
		    a >>= g;
		} while (a);
	    }
	} else {
	    c = 1;
	}

	l_MODE(c, output);
    }

    return status;
}
