/*
 * lxmile-a.c.c
 * Copyright (C) 2008-2010, 2013-2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxcall.h>
#include <lxlead.h>
#include <lxmile-inter.h>
#include <lxmile-types.h>

#define break_cycles			0

int
_libx1f4i0_lxmile_side_mile(void *subtext, void *dxpart)
{
    int status;
    unsigned call;

    call = lock_expart(dxpart)->call;
    if (call ^ 1) {
	int (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);
	struct lxmile_type *lxmile_data;

	lock_expart(dxpart)->call = call - 1;

	lxmile_data = ((struct lxtext_type *) subtext)->part;

	miss = lxmile_data->link_r.miss;
	if (miss) {
	    status = miss(lxmile_data->link_r.text, NULL, lock_excase(dxpart));
	} else {
	    status = x1f4_mind_lxlead(NULL, dxpart);
	}
    } else {
	int excess;

	lock_expart(dxpart)->call = break_cycles;

	status = _libx1f4i0_lxmile_null_mile(subtext, NULL, dxpart);

	excess = _libx1f4i0_lxmile_fine_mile(subtext, dxpart);
	if (excess) {
	    status = _libx1f4i0_lxcall_land_slip(excess, status);
	}
    }

    return status;
}
