/*
 * lxmile-inter.h
 * Copyright (C) 2008-2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxmile_inter_H__
#define __LIBx1f4_lxmile_inter_H__

#include <e4.h>
#include <lxmile-types.h>
#include <lxwide.h>
#include <nl.h>
#include <nt.h>

#define _libx1f4i0_lxmile_copy_mile	x1f4_copy_lxmile
#define _libx1f4i0_lxmile_dump_mile	x1f4_dump_lxmile
#define _libx1f4i0_lxmile_flat_mile	x1f4_flat_lxmile
#define _libx1f4i0_lxmile_free_mile	x1f4_free_lxmile
#define _libx1f4i0_lxmile_fset_mile	x1f4_fset_lxmile
#define _libx1f4i0_lxmile_hash_mile	x1f4_hash_lxmile
#define _libx1f4i0_lxmile_lead_mile	x1f4_lead_lxmile
#define _libx1f4i0_lxmile_line_mile	x1f4_line_lxmile
#define _libx1f4i0_lxmile_link_mile	x1f4_link_lxmile
#define _libx1f4i0_lxmile_move_mile	x1f4_move_lxmile
#define _libx1f4i0_lxmile_node_mile	x1f4_node_lxmile
#define _libx1f4i0_lxmile_pick_mile	x1f4_pick_lxmile
#define _libx1f4i0_lxmile_post_mile	x1f4_post_lxmile
#define _libx1f4i0_lxmile_push_mile	x1f4_push_lxmile
#define _libx1f4i0_lxmile_slip_mile	x1f4_slip_lxmile

#define _libx1f4i0_lxmile_copy_star	x1f4_copy_lxstar

#define __types_long(lxmile) \
    (&((struct lxmile_type *) (lxmile))->ever_a)

#define _libx1f4i0_lxmile_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxmile_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxmile_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

extern int _libx1f4i0_lxmile_copy_mile
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_copy_star
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_dump_mile(void *, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_fine_mile(void *, void *);
extern int _libx1f4i0_lxmile_flat_mile(void *, void **);
extern int _libx1f4i0_lxmile_free_mile
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_hash_mile
    (void *, struct x1f4_nodelink_type **, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_heap_mile
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxmile_lead_mile(void *, void **);
extern int _libx1f4i0_lxmile_line_mile(void *, void **);
extern int _libx1f4i0_lxmile_link_mile(void *, void **);
extern int _libx1f4i0_lxmile_move_mile
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_node_mile
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_null_mile
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxmile_pick_mile
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_post_mile
    (void *, void **, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_push_mile
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxmile_side_mile(void *, void *);
extern int _libx1f4i0_lxmile_slip_mile(void *, void **);
extern int _libx1f4i0_lxmile_type_mile
    (const void *, struct x1f4_nodetype_type *, int);

#endif				/* __LIBx1f4_lxmile_inter_H__ */
