/*
 * lxmode.h
 * Copyright (C) 2015, 2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxmode_H__
#define __LIBx1f4_lxmode_H__

#include <dt.h>
#include <lxlong.h>
#include <nl.h>

#undef ever_a

#define ever_a				ever_m.nice_1.east_1

#undef link_e
#undef link_m
#undef link_v
#undef link_w

#define link_e				ever_m.nice_1.east_1.diff_e
#define link_m				ever_m.nice_1.east_1.diff_m
#define link_v				ever_m.nice_1.east_1.diff_v
#define link_w				ever_m.nice_1.east_1.diff_w

#undef link_f
#undef trap_e

#define link_f				ever_m.nice_1.east_f
#define trap_e				ever_m.nice_1.east_e

#define link_t				ever_m.nice_t

#define _libx1f4i0_lxmode_push_mode	x1f4_push_lxmode

typedef struct fydata_type {
    union {
	X1f4_E4_C_MODE mode;
	X1f4_E4_C_TEXT text;
    } data;
} fydata_type;

typedef struct lxmode_type {
    struct lxlong_type nice_1;
    struct {
	struct x1f4_datatype_type datatype[2];
    } nice_t;
} lxmode_type;

extern int _libx1f4i0_lxmode_push_mode
    (void *, void **, void *, const struct x1f4_nodelink_type *);

#endif				/* __LIBx1f4_lxmode_H__ */
