/*
 * lxnear-i.b.c
 * Copyright (C) 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <cardinal.p-d.h>
#include <cardinal.p-fd.h>
#include <e4.h>
#include <lxdate.h>
#include <lxnear-drive.h>

int
_libx1f4i0_lxnear_rule_date(char *line, unsigned *rule, void *mode, int pick,
			    void *dxdate)
{
    char *n;
    struct x1f4_dxdate_type *dxdate_data;
    unsigned second_f, second_i;

    dxdate_data = dxdate;

    second_i = dxdate_data->second_i;

    switch (pick) {
    case 0:
	n = line + 4;
	*n = '-';
	x1f4_xprint_fdcardinal
	    (&n, 4, (((int) dxdate_data->second_l >> 12) + 1900) % 9999);
	n = line + 7;
	*n = '-';
	x1f4_xprint_fdcardinal(&n, 2, (second_i >> 22) + 1);
	n = line + 10;
	*n = ' ';
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 17 & 31);
	n = line + 13;
	*n = ':';
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 12 & 31);
	n = line + 16;
	*n = ':';
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 6 & 63);
	n = line + 19;
	x1f4_xprint_fdcardinal(&n, 2, second_i & 63);
	*rule = 19;
	break;

    case 'D':
	n = line + 4;
	*n = '-';
	x1f4_xprint_fdcardinal
	    (&n, 4, (((int) dxdate_data->second_l >> 12) + 1900) % 9999);
	n = line + 7;
	*n = '-';
	x1f4_xprint_fdcardinal(&n, 2, (second_i >> 22) + 1);
	n = line + 10;
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 17 & 31);
	*rule = 10;
	break;

    case 'H':
	l_MODE(second_i >> 12 & 31, mode);
	break;

    case 'M':
	l_MODE(second_i >> 6 & 63, mode);
	break;

    case 'O':
	second_f = dxdate_data->second_f;
	if (second_f) {
	    n = line + 7;
	    x1f4_xprint_dcardinal(&n, second_f);
	    memset(line + 1, '0', n - line - 1);
	    line[0] = '.';
	    n = line + 6;
	    for (; *n == '0'; n--);
	    n++;
	    *rule = n - line;
	} else {
	    *rule = 0;
	}

	break;

    case 'S':
	l_MODE(second_i & 63, mode);
	break;

    case 'T':
	n = line + 2;
	*n = ':';
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 12 & 31);
	n = line + 5;
	*n = ':';
	x1f4_xprint_fdcardinal(&n, 2, second_i >> 6 & 63);
	n = line + 8;
	x1f4_xprint_fdcardinal(&n, 2, second_i & 63);
	*rule = 8;
	break;

    case 'U':
	l_MODE(dxdate_data->second_f, mode);
	break;

    case 'Y':
	l_MODE(((int) dxdate_data->second_l >> 12) + 1900, mode);
	break;

    case 'd':
	l_MODE(second_i >> 17 & 31, mode);
	break;

    case 'm':
	l_MODE((second_i >> 22) + 1, mode);
	break;

    default:
	*rule = 0;
    }

    return 0;
}
