/*
 * lxrail-a.g.c
 * Copyright (C) 2011-2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxcall.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

#define POST_BITS \
    X1f4_LXCALL_POST_ARGS | X1f4_LXCALL_POST_DATA | X1f4_LXCALL_POST_LINE

#define lxrail(rail) \
    ((struct lxrail_type *) (rail))

int
_libx1f4i0_lxrail_long_call(struct x1f4_linetext_type *linetext_data,
			    const struct x1f4_function_type *function_data,
			    void *output, void **catch, void ***input,
			    struct center_type *center_data,
			    struct covert_type *covert_data, void *lxrail,
			    struct x1f4_linetext_type *linetext_slip)
{
    int status;

    center_data->composer_data = &lxrail(lxrail)->link_q;
    center_data->eelookup_data = lxrail(lxrail)->trap_e.eelookup_data;
    center_data->function_text = &linetext_slip->function;
    center_data->input = input;
    center_data->iturn_data = &lxrail(lxrail)->link_p;
    center_data->track_data = &lxrail(lxrail)->link_e;

    covert_data->frame_data = &lxrail(lxrail)->link_v;
    covert_data->scope_data = &lxrail(lxrail)->link_x;
    covert_data->trans_data = &lxrail(lxrail)->link_m;
    covert_data->lead = _libx1f4i0_lxrail_suit_node;
    covert_data->text = lxrail;
    covert_data->swap = NULL;

    status = _libx1f4i0_lxcall_long_call
	(linetext_data, function_data, output, (void *) catch, POST_BITS,
	 center_data, covert_data);

    return status;
}
