/*
 * lxlist-l.j.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxrail-drive.h>
#include <lxrail-types.h>

#define way_red(context)		((void **) (context))

int
_libx1f4i0_lxrail_move_rail(void *context, void *data)
{
    int status;
    unsigned link;

    link = effect_link(data);
    if (~link) {
	int (*move)(void *, void *, const struct excase_type *,
		    const struct excase_type *);
	struct lxtext_type *lxtext_data;

	lxtext_data = (struct lxtext_type *)
	    ((struct lxrail_type *) way_red(context)[1])->link_f.text + link;

	move = lxtext_data->lxtype.move;
	if (move) {
	    status = move
		(lxtext_data->lxtype.context,
		 E_USER(data), way_red(context)[2],
		 way_red(context)[3]);
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
