/*
 * lxrail-i.h.c
 * Copyright (C) 2011-2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxrail-types.h>

#define lxrail(rail) \
    ((struct lxrail_type *) (rail))

int
_libx1f4i0_lxrail_suit_node(struct center_type *center_data,
			    struct covert_type *covert_data, void *data,
			    int type)
{
    int status;
    struct lxtext_type *lxtext_data;
    unsigned miss;
    void *lxrail;

    lxrail = covert_data->text;

    lxtext_data = lxrail(lxrail)->link_f.text;
    miss = ((struct lxmiss_type *) lxtext_data - 1)->data.miss;
    for (; miss; miss--) {
	lxtext_data++;
	if (lxtext_data->lxtype.code == type) {
	    break;
	}
    }
    if (miss) {
	if (lxtext_data->lxtype.lead) {
	    status = x1f4_auto_node
		(covert_data->frame_data, center_data->track_data,
		 &lxtext_data->lxtype, data, data);
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
