/*
 * lxrail-inter.h
 * Copyright (C) 2017, 2018, 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxrail_inter_H__
#define __LIBx1f4_lxrail_inter_H__

#include <lxcall.h>
#include <lxrail-types.h>

#define __types_lock(lxrail) \
    (&__types_long(lxrail)->east_1)

#define __types_long(lxrail) \
    (&((struct lxrail_type *) (lxrail))->ever_p.rule_1.nice_1)

#define _libx1f4i0_lxrail_stat_land(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_land(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxrail_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxrail_stat_roll(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_roll(__types_lock((___l)))
#define _libx1f4i0_lxrail_stat_zero(___l) \
    _libx1f4i0_lxlock_stat_zero(__types_lock((___l)))

extern int _libx1f4i0_lxrail_draw_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, void *);
extern int _libx1f4i0_lxrail_fold_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, void *);
extern int _libx1f4i0_lxrail_form_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, int, void *);
extern int _libx1f4i0_lxrail_into_rail
    (void *, void *, void **, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, void *, int,
     int (*)(struct lxrail_type *, struct fydata_type *, void *));
extern int _libx1f4i0_lxrail_jack_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, void *);
extern int _libx1f4i0_lxrail_lift_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, void *);
extern int _libx1f4i0_lxrail_long_call
    (struct x1f4_linetext_type *, const struct x1f4_function_type *,
     void *, void **, void ***, struct center_type *, struct covert_type *,
     void *, struct x1f4_linetext_type *);
extern int _libx1f4i0_lxrail_loop_call
    (void *, void *, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, int, void *);
extern int _libx1f4i0_lxrail_slip_poll(void *);
extern int _libx1f4i0_lxrail_slip_roll(void *);
extern int _libx1f4i0_lxrail_suit_node
    (struct center_type *, struct covert_type *, void *, int);
extern int _libx1f4i0_lxrail_unto_rail
    (void *, void *, void **, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, void *, struct cxroll_type *,
     void *, int (*)(void *), void *,
     int (*)(struct lxrail_type *, struct direct_type *, void *, void *,
	     unsigned *));
extern int _libx1f4i0_lxrail_wide_rail
    (void *, void *, void **, void **, struct x1f4_linetext_type *, unsigned,
     const struct x1f4_function_type *, int, int, int, void *, int,
     int (*)(struct lxrail_type *, struct affect_type *, void *, unsigned *));

#endif				/* __LIBx1f4_lxrail_inter_H__ */
