/*
 * lxrail-o.n.c
 * Copyright (C) 2014-2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxrail-types.h>
#include <mxdeck.h>

int
_libx1f4i0_lxrail_link_fast(struct x1f4_linetrap_type *linetrap_data,
			    struct depart_type *depart_data,
			    const struct patent_type *patent_data)
{
    struct x1f4_fpdetail_type *fpdetail_data;
    struct x1f4_ftsl_type *ftsl_data;
    unsigned i, pass;

    fpdetail_data = depart_data->fpdetail_slot;

    pass = fpdetail_data[1].ftsl_data - fpdetail_data[0].ftsl_data - 1;

    i = 4;
    for (; i; i--) {
	ftsl_data = (void *) fpdetail_data->ftsl_data;

	ftsl_data->linetext_data = NULL;
	ftsl_data->type = X1f4_E4_VOID;

	fpdetail_data->ftsl_data = ftsl_data - pass;

	x1f4_post_mxpath
	    (linetrap_data->fpaccess, patent_data->name, patent_data->size,
	     fpdetail_data);

	patent_data++;

	fpdetail_data++;
    }

    return 0;
}
