/*
 * lxstar-a.b.c
 * Copyright (C) 2008-2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <exerrors.h>
#include <lxfset.h>
#include <lxlead.h>
#include <lxpart-inter.h>
#include <lxpart-types.h>
#include <nl.h>
#include <tcvset.h>

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_copy_lxstar(void *subtext, void *bppp, void **copy, const void *part,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;

    status = tccase(lock_expart(part)->text)->push
	(&lock_expart(part)->pset, &lock_expart(part)->text, nodelink_data,
	 &((struct lxpart_type *)
	   ((struct lxtext_type *) subtext)->part)->link_m);
    if (status) {
	status = X1f4_EX_CRITICAL;
    } else {
	*copy = (void *) part;

	lock_expart(part)->call++;
    }

    return status;
}
