/*
 * lxtext-a.e.c
 * Copyright (C) 2008-2014, 2016, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <er.h>
#include <exerrors.h>
#include <lxtext-types.h>

#define lxtext(lxtext) \
    ((struct lxtext_type *) (lxtext))

int
_libx1f4i0_lxtext_stat_band(void *lxtext, long band)
{
    LINE_EEER(lxtext(lxtext)->link_e);

    PUSH_DATA("negative digit count (", 22);
    PUSH_LONG(band);
    PUSH_DATA(")", 1);

    POST_EEER();

    return X1f4_EX_CAN_CONTINUE;
}


int
_libx1f4i0_lxtext_stat_lock(void *lxtext, long lock)
{
    LINE_EEER(lxtext(lxtext)->link_e);

    PUSH_DATA("negative digit block width (", 28);
    PUSH_LONG(lock);
    PUSH_DATA(")", 1);

    POST_EEER();

    return X1f4_EX_CAN_CONTINUE;
}
