/*
 * lxtext-e.2.c
 * Copyright (C) 2008-2010, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <string.h>

#include <e4.h>
#include <lcardinal.p-d.h>
#include <lxtext-inter.h>
#include <lxtext-types.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxtext_i101214_1(void *context, void *output, void **input)
{
    int status;
    struct lxtext_type *lxtext_data;
    void *text;

    lxtext_data = context;

    status = lxtext_data->link_v.link(lxtext_data->link_v.data, &text, 21);
    if (status) {
	status = _libx1f4i0_lxtext_stat_link(lxtext_data);
    } else {
	char *miss;

	miss = (char *) text + 20;
	*miss = 0;
	x1f4_xprint_dlcardinal(&miss, I_BILL(input[0]));

	l_TEXT(miss, output);
    }

    return status;
}
