/*
 * lxtext-inter.h
 * Copyright (C) 2008-2012, 2014, 2016, 2019-2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxtext_inter_H__
#define __LIBx1f4_lxtext_inter_H__

#include <e4.h>
#include <lxlock.h>
#include <lxtext-types.h>
#include <lxwide.h>

#define _libx1f4i0_lxtext_bset_text	x1f4_bset_lxtext
#define _libx1f4i0_lxtext_fini_text	x1f4_fini_lxtext
#define _libx1f4i0_lxtext_fset_text	x1f4_fset_lxtext
#define _libx1f4i0_lxtext_init_text	x1f4_init_lxtext
#define _libx1f4i0_lxtext_near_text	x1f4_near_lxtext
#define _libx1f4i0_lxtext_tile_text	x1f4_tile_lxtext

#define __types_lock(lxtext) \
    (&((struct lxtext_type *) (lxtext))->ever_a)

#define _libx1f4i0_lxtext_stat_base(___l, ___1) \
    _libx1f4i0_lxlock_stat_base(__types_lock((___l)), (___1))
#define _libx1f4i0_lxtext_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), (___1))
#define _libx1f4i0_lxtext_stat_line(___l, ___1) \
    _libx1f4i0_lxlock_stat_line(__types_lock((___l)), (___1))
#define _libx1f4i0_lxtext_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxtext_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))

extern int _libx1f4i0_lxtext_bset_text
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxtext_i080104_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i080104_1(void *, void *, void **);
extern int _libx1f4i0_lxtext_i080106_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i080106_1(void *, void *, void **);
extern int _libx1f4i0_lxtext_i080106_2(void *, void *, void **);
extern int _libx1f4i0_lxtext_i081113_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i081113_1(void *, void *, void **);
extern int _libx1f4i0_lxtext_i081113_2(void *, void *, void **);
extern int _libx1f4i0_lxtext_i091125_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i091125_1(void *, void *, void **);
extern int _libx1f4i0_lxtext_i091125_2(void *, void *, void **);
extern int _libx1f4i0_lxtext_i101031_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i101214_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i101214_1(void *, void *, void **);
extern int _libx1f4i0_lxtext_i101218_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i120110_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i140306_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i141027_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_i200731_0(void *, void *, void **);
extern int _libx1f4i0_lxtext_fini_text(void **);
extern int _libx1f4i0_lxtext_fset_text
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxtext_init_text
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxtext_near_text(void *);
extern int _libx1f4i0_lxtext_stat_band(void *, long);
extern int _libx1f4i0_lxtext_stat_lock(void *, long);
extern int _libx1f4i0_lxtext_tile_text
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);

#endif				/* __LIBx1f4_lxtext_inter_H__ */

