/*
 * lxtrap-f.a.c
 * Copyright (C) 2019, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include <e4.h>
#include <lxcast.h>
#include <lxtrap-drive.h>
#include <lxtrap-inter.h>
#include <lxtrap-types.h>

int
_libx1f4i0_lxtrap_a_forward(void *context, void *output, void **input)
{
    int status = 0;
    unsigned char *rule = NULL;

    do {
	int type;
	const int *fill;
	struct lxtrap_type *lxtrap_data;
	struct x1f4_dxcast_type *dxcast_data;
	struct x1f4_function_type *function_data;
	struct x1f4_linetext_type *linetext_data;
	unsigned fold, i, late, mill, rise;
	void **order, **used;

	lxtrap_data = context;

	dxcast_data = I_USER(input[0]);

	linetext_data = I_USER(&dxcast_data->data);

	used = input[-1];

	function_data = used[X1f4_E4_RENDITION];

	fold = function_data->count - 1;

	if (fold) {
	} else {
	    l_USER(dxcast_data, output);

	    break;
	}

	if (fold & 1) {
	    status = _libx1f4i0_lxtrap_stat_even(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	if (254 < fold) {
	    status = _libx1f4i0_lxtrap_stat_over(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	mill = linetext_data->function.count;

	late = mill;

	rule = malloc(mill);
	if (rule) {
	} else {
	    status = _libx1f4i0_lxtrap_stat_link(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	fill = function_data->args - 1;

	order = input - 1;

	memset(rule, 0, mill);

	fold += 2;
	for (i = 2; i < fold; i += 2) {
	    X1f4_E4_C_MODE mode;

	    fill += 2;

	    type = *fill;
	    if (type != X1f4_E4_MODE) {
		status = _libx1f4i0_lxtrap_stat_iran(context, i - 1);
		if (1) {
		    break;
		}
	    }

	    order += 2;

	    mode = I_MODE(*order);
	    status = _libx1f4i0_lxtrap_mill_lock(context, &mode, mill);
	    if (status) {
		break;
	    }

	    if (rule[mode]) {
	    } else {
		late--;
	    }

	    rule[mode] = i;
	}
	if (status) {
	    break;
	}

	rise = 0;
	for (i = mill; i; i--) {
	    if (*rule++) {
		if (255 < rise) {
		    status = _libx1f4i0_lxtrap_stat_rise(context);
		    if (1) {
			break;
		    }
		} else {
		    rise = 0;
		}
	    } else {
		rise++;
	    }
	}

	rule += i;
	rule -= mill;

	if (status) {
	    break;
	}

	fold = mill - late;

	status = _libx1f4i0_lxtrap_half_into
	    (context, output, input, linetext_data, function_data, fold, late,
	     mill, &rule);
    } while (0);

    if (rule) {
	free(rule);
    }

    return status;
}
