/*
 * lxtrap-i.h.c
 * Copyright (C) 2011-2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxtrap-drive.h>
#include <lxtrap-types.h>

#define lxtrap(lxtrap) \
    ((struct lxtrap_type *) (lxtrap))

int
_libx1f4i0_lxtrap_suit_node(struct center_type *center_data,
			    struct covert_type *covert_data, void *data,
			    int type)
{
    int status;
    const struct lxtype_type *lxtype_data;
    unsigned miss;
    void *lxtrap;

    lxtrap = covert_data->text;

    lxtype_data = lxtrap(lxtrap)->link_t.data;
    miss = lxtrap(lxtrap)->link_t.miss;
    for (; miss; miss--) {
	lxtype_data++;
	if (lxtype_data->type == type) {
	    break;
	}
    }
    if (miss) {
	if (lxtype_data->lead) {
	    status = _libx1f4i0_lxcall_pick_deck
		(&lxtrap(lxtrap)->link_v, &lxtrap(lxtrap)->link_e,
		 lxtype_data->lead, lxtype_data->slip, lxtype_data->text,
		 I_USER(data), data);
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
