/*
 * lxvery-d.m.c
 * Copyright (C) 2008-2015, 2017, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxvery-config.h>

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

static int push_mode(void *, void *);

static int
push_mode(void *dxvery, void *data)
{
    int status;
    struct dxvery_type *dxvery_data;
#if __VERY_PSET__
#else
    void *text;
#endif				/* __VERY_PSET__ */

    dxvery_data = dxvery;

#if __VERY_PSET__
    status = x1f4_post_bqpset(dxvery_data->dash, *(void **) data);
#else
    status = x1f4_post_lxfset(dxvery_data->dash, data, &text);
#endif				/* __VERY_PSET__ */
    if (status) {
	if (status == X1f4_BQFSET_EVER_MATCH) {
	    status = 0;
	} else {
	}
    } else {
#if __VERY_PSET__
#else
	X1f4_E4_C_MODE *trip;

	trip = text;

	*trip = *(X1f4_E4_C_MODE *) data;
#endif				/* __VERY_PSET__ */

	dxvery_data->size++;
    }

    return status;
}


int
_libx1f4i0_lxvery_m_derived(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_data, *dxvery_text;

    dxvery_data = I_LINE(input[0]);
    dxvery_text = I_LINE(input[1]);

    if (dxvery_data->size < dxvery_text->size) {
	_libx1f4i0_lxvery_swap_line(dxvery_data, dxvery_text);
    }

    status = x1f4_lime_bqfset(dxvery_text->dash, dxvery_data, push_mode);
    if (status) {
	status = _libx1f4i0_lxvery_stat_line(context, 0, status);
    } else {
	status = _libx1f4i0_lxvery_null_line(context, NULL, dxvery_text);
	if (status) {
	} else {
	    l_LINE(dxvery_data, output);
	}
    }

    return status;
}
