/*
 * lxvery-l.j.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxvery-config.h>

#include <c-types.h>
#include <e4.h>
#include <d_fset.h>
#include <lxcall.h>
#include <lxvery-defs.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#if __VERY_PSET__
# define F_TYPE				C_BILL
#else
# define F_TYPE				C_MODE
#endif				/* __VERY_PSET__ */

int
_libx1f4i0_lxvery_j_logique(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_data, *dxvery_text;

    dxvery_data = I_LINE(input[0]);
    dxvery_text = I_LINE(input[1]);

    do {
	void *ever, *lead;

	if (dxvery_data == dxvery_text) {
	    status = 0;
	    break;
	}
	status = _libx1f4i0_lead_lxfset(dxvery_text->dash, &lead);
	if (status) {
	    if (status == X1f4_BQFSET_DECK_ERROR) {
	    } else {
		status = _libx1f4i0_lxvery_stat_line(context, 0, status);
		break;
	    }
	} else {
	    status = _libx1f4i0_ever_lxfset(dxvery_data->dash, &ever);
	    if (status) {
		if (status == X1f4_BQFSET_DECK_ERROR) {
		} else {
		    status = _libx1f4i0_lxvery_stat_line(context, 0, status);
		    break;
		}
	    } else {
		if (*(F_TYPE *) ever < *(F_TYPE *) lead) {
		} else {
		    status = _libx1f4i0_lxvery_stat_join(context);
		    break;
		}
	    }
	}
	status = _libx1f4i0_join_lxfset(dxvery_data->dash, dxvery_text->dash);
	if (status) {
	} else {
	    dxvery_data->size += dxvery_text->size;
	    dxvery_text->size = 0;
	}
    } while (0);

    if (status) {
    } else {
	l_LINE(dxvery_data, output);
    }

    return status;
}
