/*
 * lxvery-p.v.c
 * Copyright (C) 2011-2019, 2021, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcast.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

extern const void *const x1f4_a1_walk_link;

int
_libx1f4i0_lxvery_v_pending(void *context, void *output, void **input)
{
    struct dxvery_type *dxvery_data;
    void **track;

    if (output == x1f4_a1_walk_link) {
	track = input[1];
    } else {
	track = input;
    }

    dxvery_data = I_LINE(track[0]);

    return _libx1f4i0_lxrail_v_pending
	(context, output, input, track, dxvery_data, X1f4_E4_MODE,
	 dxvery_data->size, "i_vcall", _libx1f4i0_lxvery_very_line);
}
