/*
 * lxxsxx-1.k.c
 * Copyright (C) 2008-2012, 2014, 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <signal.h>

#include <lxport-drive.h>
#include <lxport-inter.h>
#include <lxport-types.h>

#define xsport(port) \
    ((struct xsport_type *) (port))

int
_libx1f4i0_lxport_k_1xshell(void *context, void *output, void **input)
{
    int pid, status;
    struct xsport_type *xsport_data;

    xsport_data = I_PORT(input[0]);

    pid = xsport(I_PORT(input[0]))->waitlink_data->port;
    if (~pid) {
	status = kill(pid, I_MODE(input[1]));
	if (status) {
	    if (errno == ESRCH) {
		status = 0;
	    } else {
		status = _libx1f4i0_lxport_stat_call(context, "kill", 4);
	    }
	}
    } else {
	status = 0;
    }

    l_XSXX(xsport_data, output);

    return status;
}
