/*
 * lintegral.f.c
 * Copyright (C) 2006-2007, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stdio.h>

#if defined LIBx1f4i0
# include <inter.h>
#endif				/* LIBx1f4i0 */
#if !defined LIBx1f4i0
# include <lintegral.p.h>
#endif				/* !LIBx1f4i0 */

#define BASE_SIZE		(SIZEOF_UNSIGNED_LONG << 3)
#define SIGN_SIZE		(BASE_SIZE + 1)

int
x1f4_fprint_lintegral(FILE *file, int big, unsigned base, long c)
{
    char data[SIGN_SIZE], *mode;

    mode = data + SIGN_SIZE;
    x1f4_xprint_lintegral(&mode, big, base, c);

    return fprintf(file, "%.*s", (int) (data + SIGN_SIZE - mode), mode);
}
